/*
**  MMXmem benchmarks for RAMspeed (amd64)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2005 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

.globl mmxcp
mmxcp:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	%rbx, %rcx
	shrq	$3, %rcx
	movq	%r12, %rdi
.precp:
	movw	$33, 0(%rdi)
	movw	$33, 2(%rdi)
	movw	$33, 4(%rdi)
	movw	$33, 6(%rdi)
	addq	$8, %rdi
	loopq	.precp
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$8, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	$256, %rax
.maincp:
	movq	0(%rdi), %mm0
	movq	8(%rdi), %mm1
	movq	16(%rdi), %mm2
	movq	24(%rdi), %mm3
	movq	%mm0, 0(%rsi)
	movq	%mm1, 8(%rsi)
	movq	%mm2, 16(%rsi)
	movq	%mm3, 24(%rsi)
	movq	32(%rdi), %mm0
	movq	40(%rdi), %mm1
	movq	48(%rdi), %mm2
	movq	56(%rdi), %mm3
	movq	%mm0, 32(%rsi)
	movq	%mm1, 40(%rsi)
	movq	%mm2, 48(%rsi)
	movq	%mm3, 56(%rsi)
	movq	64(%rdi), %mm0
	movq	72(%rdi), %mm1
	movq	80(%rdi), %mm2
	movq	88(%rdi), %mm3
	movq	%mm0, 64(%rsi)
	movq	%mm1, 72(%rsi)
	movq	%mm2, 80(%rsi)
	movq	%mm3, 88(%rsi)
	movq	96(%rdi), %mm0
	movq	104(%rdi), %mm1
	movq	112(%rdi), %mm2
	movq	120(%rdi), %mm3
	movq	%mm0, 96(%rsi)
	movq	%mm1, 104(%rsi)
	movq	%mm2, 112(%rsi)
	movq	%mm3, 120(%rsi)
	movq	128(%rdi), %mm0
	movq	136(%rdi), %mm1
	movq	144(%rdi), %mm2
	movq	152(%rdi), %mm3
	movq	%mm0, 128(%rsi)
	movq	%mm1, 136(%rsi)
	movq	%mm2, 144(%rsi)
	movq	%mm3, 152(%rsi)
	movq	160(%rdi), %mm0
	movq	168(%rdi), %mm1
	movq	176(%rdi), %mm2
	movq	184(%rdi), %mm3
	movq	%mm0, 160(%rsi)
	movq	%mm1, 168(%rsi)
	movq	%mm2, 176(%rsi)
	movq	%mm3, 184(%rsi)
	movq	192(%rdi), %mm0
	movq	200(%rdi), %mm1
	movq	208(%rdi), %mm2
	movq	216(%rdi), %mm3
	movq	%mm0, 192(%rsi)
	movq	%mm1, 200(%rsi)
	movq	%mm2, 208(%rsi)
	movq	%mm3, 216(%rsi)
	movq	224(%rdi), %mm0
	movq	232(%rdi), %mm1
	movq	240(%rdi), %mm2
	movq	248(%rdi), %mm3
	movq	%mm0, 224(%rsi)
	movq	%mm1, 232(%rsi)
	movq	%mm2, 240(%rsi)
	movq	%mm3, 248(%rsi)
	addq	%rax, %rdi
	addq	%rax, %rsi
	decq	%rcx
	jnz	.maincp

	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.maincp

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxsc
mmxsc:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	%rbx, %rcx
	shrq	$3, %rcx
	movq	%r12, %rdi
.presc:
	movw	$33, 0(%rdi)
	movw	$33, 2(%rdi)
	movw	$33, 4(%rdi)
	movw	$33, 6(%rdi)
	addq	$8, %rdi
	loopq	.presc
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	movw	$77, 16(%rsp)
	movw	$77, 18(%rsp)
	movw	$77, 20(%rsp)
	movw	$77, 22(%rsp)
	movq	16(%rsp), %mm4
/* execute */
	shrq	$8, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	$256, %rax
.mainsc:
	movq	0(%rdi), %mm0
	movq	8(%rdi), %mm1
	movq	16(%rdi), %mm2
	movq	24(%rdi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 0(%rsi)
	movq	%mm1, 8(%rsi)
	movq	%mm2, 16(%rsi)
	movq	%mm3, 24(%rsi)
	movq	32(%rdi), %mm0
	movq	40(%rdi), %mm1
	movq	48(%rdi), %mm2
	movq	56(%rdi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 32(%rsi)
	movq	%mm1, 40(%rsi)
	movq	%mm2, 48(%rsi)
	movq	%mm3, 56(%rsi)
	movq	64(%rdi), %mm0
	movq	72(%rdi), %mm1
	movq	80(%rdi), %mm2
	movq	88(%rdi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 64(%rsi)
	movq	%mm1, 72(%rsi)
	movq	%mm2, 80(%rsi)
	movq	%mm3, 88(%rsi)
	movq	96(%rdi), %mm0
	movq	104(%rdi), %mm1
	movq	112(%rdi), %mm2
	movq	120(%rdi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 96(%rsi)
	movq	%mm1, 104(%rsi)
	movq	%mm2, 112(%rsi)
	movq	%mm3, 120(%rsi)
	movq	128(%rdi), %mm0
	movq	136(%rdi), %mm1
	movq	144(%rdi), %mm2
	movq	152(%rdi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 128(%rsi)
	movq	%mm1, 136(%rsi)
	movq	%mm2, 144(%rsi)
	movq	%mm3, 152(%rsi)
	movq	160(%rdi), %mm0
	movq	168(%rdi), %mm1
	movq	176(%rdi), %mm2
	movq	184(%rdi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 160(%rsi)
	movq	%mm1, 168(%rsi)
	movq	%mm2, 176(%rsi)
	movq	%mm3, 184(%rsi)
	movq	192(%rdi), %mm0
	movq	200(%rdi), %mm1
	movq	208(%rdi), %mm2
	movq	216(%rdi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 192(%rsi)
	movq	%mm1, 200(%rsi)
	movq	%mm2, 208(%rsi)
	movq	%mm3, 216(%rsi)
	movq	224(%rdi), %mm0
	movq	232(%rdi), %mm1
	movq	240(%rdi), %mm2
	movq	248(%rdi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 224(%rsi)
	movq	%mm1, 232(%rsi)
	movq	%mm2, 240(%rsi)
	movq	%mm3, 248(%rsi)
	addq	%rax, %rdi
	addq	%rax, %rsi
	decq	%rcx
	jnz	.mainsc

	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainsc

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxad
mmxad:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	%rbx, %rcx
	shrq	$3, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
.pread:
	movw	$33, 0(%rdi)
	movw	$33, 2(%rdi)
	movw	$33, 4(%rdi)
	movw	$33, 6(%rdi)
	movw	$55, 0(%rsi)
	movw	$55, 2(%rsi)
	movw	$55, 4(%rsi)
	movw	$55, 6(%rsi)
	addq	$8, %rdi
	addq	$8, %rsi
	loopq	.pread
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$8, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%r14, %rbp
	movq	$256, %rax
.mainad:
	movq	0(%rdi), %mm0
	movq	8(%rdi), %mm1
	movq	16(%rdi), %mm2
	movq	24(%rdi), %mm3
	paddusw	0(%rsi), %mm0
	paddusw	8(%rsi), %mm1
	paddusw	16(%rsi), %mm2
	paddusw	24(%rsi), %mm3
	movq	%mm0, 0(%rbp)
	movq	%mm1, 8(%rbp)
	movq	%mm2, 16(%rbp)
	movq	%mm3, 24(%rbp)
	movq	32(%rdi), %mm0
	movq	40(%rdi), %mm1
	movq	48(%rdi), %mm2
	movq	54(%rdi), %mm3
	paddusw	32(%rsi), %mm0
	paddusw	40(%rsi), %mm1
	paddusw	48(%rsi), %mm2
	paddusw	54(%rsi), %mm3
	movq	%mm0, 32(%rbp)
	movq	%mm1, 40(%rbp)
	movq	%mm2, 48(%rbp)
	movq	%mm3, 54(%rbp)
	movq	64(%rdi), %mm0
	movq	72(%rdi), %mm1
	movq	80(%rdi), %mm2
	movq	88(%rdi), %mm3
	paddusw	64(%rsi), %mm0
	paddusw	72(%rsi), %mm1
	paddusw	80(%rsi), %mm2
	paddusw	88(%rsi), %mm3
	movq	%mm0, 64(%rbp)
	movq	%mm1, 72(%rbp)
	movq	%mm2, 80(%rbp)
	movq	%mm3, 88(%rbp)
	movq	96(%rdi), %mm0
	movq	104(%rdi), %mm1
	movq	112(%rdi), %mm2
	movq	120(%rdi), %mm3
	paddusw	96(%rsi), %mm0
	paddusw	104(%rsi), %mm1
	paddusw	112(%rsi), %mm2
	paddusw	120(%rsi), %mm3
	movq	%mm0, 96(%rbp)
	movq	%mm1, 104(%rbp)
	movq	%mm2, 112(%rbp)
	movq	%mm3, 120(%rbp)
	movq	128(%rdi), %mm0
	movq	136(%rdi), %mm1
	movq	144(%rdi), %mm2
	movq	152(%rdi), %mm3
	paddusw	128(%rsi), %mm0
	paddusw	136(%rsi), %mm1
	paddusw	144(%rsi), %mm2
	paddusw	152(%rsi), %mm3
	movq	%mm0, 128(%rbp)
	movq	%mm1, 136(%rbp)
	movq	%mm2, 144(%rbp)
	movq	%mm3, 152(%rbp)
	movq	160(%rdi), %mm0
	movq	168(%rdi), %mm1
	movq	176(%rdi), %mm2
	movq	184(%rdi), %mm3
	paddusw	160(%rsi), %mm0
	paddusw	168(%rsi), %mm1
	paddusw	176(%rsi), %mm2
	paddusw	184(%rsi), %mm3
	movq	%mm0, 160(%rbp)
	movq	%mm1, 168(%rbp)
	movq	%mm2, 176(%rbp)
	movq	%mm3, 184(%rbp)
	movq	192(%rdi), %mm0
	movq	200(%rdi), %mm1
	movq	208(%rdi), %mm2
	movq	216(%rdi), %mm3
	paddusw	192(%rsi), %mm0
	paddusw	200(%rsi), %mm1
	paddusw	208(%rsi), %mm2
	paddusw	216(%rsi), %mm3
	movq	%mm0, 192(%rbp)
	movq	%mm1, 200(%rbp)
	movq	%mm2, 208(%rbp)
	movq	%mm3, 216(%rbp)
	movq	224(%rdi), %mm0
	movq	232(%rdi), %mm1
	movq	240(%rdi), %mm2
	movq	248(%rdi), %mm3
	paddusw	224(%rsi), %mm0
	paddusw	232(%rsi), %mm1
	paddusw	240(%rsi), %mm2
	paddusw	248(%rsi), %mm3
	movq	%mm0, 224(%rbp)
	movq	%mm1, 232(%rbp)
	movq	%mm2, 240(%rbp)
	movq	%mm3, 248(%rbp)
	addq	%rax, %rdi
	addq	%rax, %rsi
	addq	%rax, %rbp
	decq	%rcx
	jnz	.mainad

	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%r14, %rbp
	movq	%rbx, %rcx
	decq	%r15
	jnz	.mainad

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxtr
mmxtr:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	%rbx, %rcx
	shrq	$3, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
.pretr:
	movw	$33, 0(%rdi)
	movw	$33, 2(%rdi)
	movw	$33, 4(%rdi)
	movw	$33, 6(%rdi)
	movw	$55, 0(%rsi)
	movw	$55, 2(%rsi)
	movw	$55, 4(%rsi)
	movw	$55, 6(%rsi)
	addq	$8, %rdi
	addq	$8, %rsi
	loopq	.pretr
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	movw	$77, 16(%rsp)
	movw	$77, 18(%rsp)
	movw	$77, 20(%rsp)
	movw	$77, 22(%rsp)
	movq	16(%rsp), %mm4
/* execute */
	shrq	$8, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%r14, %rbp
	movq	$256, %rax
.maintr:
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	0(%rdi), %mm0
	paddusw	8(%rdi), %mm1
	paddusw	16(%rdi), %mm2
	paddusw	24(%rdi), %mm3
	movq	%mm0, 0(%rbp)
	movq	%mm1, 8(%rbp)
	movq	%mm2, 16(%rbp)
	movq	%mm3, 24(%rbp)
	movq	32(%rsi), %mm0
	movq	40(%rsi), %mm1
	movq	48(%rsi), %mm2
	movq	56(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	32(%rdi), %mm0
	paddusw	40(%rdi), %mm1
	paddusw	48(%rdi), %mm2
	paddusw	56(%rdi), %mm3
	movq	%mm0, 32(%rbp)
	movq	%mm1, 40(%rbp)
	movq	%mm2, 48(%rbp)
	movq	%mm3, 56(%rbp)
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	64(%rdi), %mm0
	paddusw	72(%rdi), %mm1
	paddusw	80(%rdi), %mm2
	paddusw	88(%rdi), %mm3
	movq	%mm0, 64(%rbp)
	movq	%mm1, 72(%rbp)
	movq	%mm2, 80(%rbp)
	movq	%mm3, 88(%rbp)
	movq	96(%rsi), %mm0
	movq	104(%rsi), %mm1
	movq	112(%rsi), %mm2
	movq	120(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	96(%rdi), %mm0
	paddusw	104(%rdi), %mm1
	paddusw	112(%rdi), %mm2
	paddusw	120(%rdi), %mm3
	movq	%mm0, 96(%rbp)
	movq	%mm1, 104(%rbp)
	movq	%mm2, 112(%rbp)
	movq	%mm3, 120(%rbp)
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	128(%rdi), %mm0
	paddusw	136(%rdi), %mm1
	paddusw	144(%rdi), %mm2
	paddusw	152(%rdi), %mm3
	movq	%mm0, 128(%rbp)
	movq	%mm1, 136(%rbp)
	movq	%mm2, 144(%rbp)
	movq	%mm3, 152(%rbp)
	movq	160(%rsi), %mm0
	movq	168(%rsi), %mm1
	movq	176(%rsi), %mm2
	movq	184(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	160(%rdi), %mm0
	paddusw	168(%rdi), %mm1
	paddusw	176(%rdi), %mm2
	paddusw	184(%rdi), %mm3
	movq	%mm0, 160(%rbp)
	movq	%mm1, 168(%rbp)
	movq	%mm2, 176(%rbp)
	movq	%mm3, 184(%rbp)
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	192(%rdi), %mm0
	paddusw	200(%rdi), %mm1
	paddusw	208(%rdi), %mm2
	paddusw	216(%rdi), %mm3
	movq	%mm0, 192(%rbp)
	movq	%mm1, 200(%rbp)
	movq	%mm2, 208(%rbp)
	movq	%mm3, 216(%rbp)
	movq	224(%rsi), %mm0
	movq	232(%rsi), %mm1
	movq	240(%rsi), %mm2
	movq	248(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	224(%rdi), %mm0
	paddusw	232(%rdi), %mm1
	paddusw	240(%rdi), %mm2
	paddusw	248(%rdi), %mm3
	movq	%mm0, 224(%rbp)
	movq	%mm1, 232(%rbp)
	movq	%mm2, 240(%rbp)
	movq	%mm3, 248(%rbp)
	addq	%rax, %rdi
	addq	%rax, %rsi
	addq	%rax, %rbp
	decq	%rcx
	jnz	.maintr

	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%r14, %rbp
	movq	%rbx, %rcx
	decq	%r15
	jnz	.maintr

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret
