/*
**  SSEmark benchmarks for RAMspeed (amd64)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2005 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

.globl ssewr
ssewr:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	$1024, %rax
	xorps	%xmm0, %xmm0
.mainwr:
	movaps	%xmm0, 0(%rdi)
	movaps	%xmm0, 16(%rdi)
	movaps	%xmm0, 32(%rdi)
	movaps	%xmm0, 48(%rdi)
	movaps	%xmm0, 64(%rdi)
	movaps	%xmm0, 80(%rdi)
	movaps	%xmm0, 96(%rdi)
	movaps	%xmm0, 112(%rdi)
	movaps	%xmm0, 128(%rdi)
	movaps	%xmm0, 144(%rdi)
	movaps	%xmm0, 160(%rdi)
	movaps	%xmm0, 176(%rdi)
	movaps	%xmm0, 192(%rdi)
	movaps	%xmm0, 208(%rdi)
	movaps	%xmm0, 224(%rdi)
	movaps	%xmm0, 240(%rdi)
	movaps	%xmm0, 256(%rdi)
	movaps	%xmm0, 272(%rdi)
	movaps	%xmm0, 288(%rdi)
	movaps	%xmm0, 304(%rdi)
	movaps	%xmm0, 320(%rdi)
	movaps	%xmm0, 336(%rdi)
	movaps	%xmm0, 352(%rdi)
	movaps	%xmm0, 368(%rdi)
	movaps	%xmm0, 384(%rdi)
	movaps	%xmm0, 400(%rdi)
	movaps	%xmm0, 416(%rdi)
	movaps	%xmm0, 432(%rdi)
	movaps	%xmm0, 448(%rdi)
	movaps	%xmm0, 464(%rdi)
	movaps	%xmm0, 480(%rdi)
	movaps	%xmm0, 496(%rdi)
	movaps	%xmm0, 512(%rdi)
	movaps	%xmm0, 528(%rdi)
	movaps	%xmm0, 544(%rdi)
	movaps	%xmm0, 560(%rdi)
	movaps	%xmm0, 576(%rdi)
	movaps	%xmm0, 592(%rdi)
	movaps	%xmm0, 608(%rdi)
	movaps	%xmm0, 624(%rdi)
	movaps	%xmm0, 640(%rdi)
	movaps	%xmm0, 656(%rdi)
	movaps	%xmm0, 672(%rdi)
	movaps	%xmm0, 688(%rdi)
	movaps	%xmm0, 704(%rdi)
	movaps	%xmm0, 720(%rdi)
	movaps	%xmm0, 736(%rdi)
	movaps	%xmm0, 752(%rdi)
	movaps	%xmm0, 768(%rdi)
	movaps	%xmm0, 784(%rdi)
	movaps	%xmm0, 800(%rdi)
	movaps	%xmm0, 816(%rdi)
	movaps	%xmm0, 832(%rdi)
	movaps	%xmm0, 848(%rdi)
	movaps	%xmm0, 864(%rdi)
	movaps	%xmm0, 880(%rdi)
	movaps	%xmm0, 896(%rdi)
	movaps	%xmm0, 912(%rdi)
	movaps	%xmm0, 928(%rdi)
	movaps	%xmm0, 944(%rdi)
	movaps	%xmm0, 960(%rdi)
	movaps	%xmm0, 976(%rdi)
	movaps	%xmm0, 992(%rdi)
	movaps	%xmm0, 1008(%rdi)
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainwr

	movq	%r12, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainwr

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl sserd
sserd:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* save the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* prefill */
	movq	%rbx, %rcx
	shlq	$4, %rcx
	xorps	%xmm0, %xmm0
.prerd:
	movaps	%xmm0, 0(%rax)
	movaps	%xmm0, 16(%rax)
	movaps	%xmm0, 32(%rax)
	movaps	%xmm0, 48(%rax)
	addq	$64, %rax
	loopq	.prerd
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	$1024, %rax
.mainrd:
	movaps	0(%rdi), %xmm0
	movaps	16(%rdi), %xmm1
	movaps	32(%rdi), %xmm2
	movaps	48(%rdi), %xmm3
	movaps	64(%rdi), %xmm4
	movaps	80(%rdi), %xmm5
	movaps	96(%rdi), %xmm6
	movaps	112(%rdi), %xmm7
	movaps	128(%rdi), %xmm8
	movaps	144(%rdi), %xmm9
	movaps	160(%rdi), %xmm10
	movaps	176(%rdi), %xmm11
	movaps	192(%rdi), %xmm12
	movaps	208(%rdi), %xmm13
	movaps	224(%rdi), %xmm14
	movaps	240(%rdi), %xmm15
	movaps	256(%rdi), %xmm0
	movaps	272(%rdi), %xmm1
	movaps	288(%rdi), %xmm2
	movaps	304(%rdi), %xmm3
	movaps	320(%rdi), %xmm4
	movaps	336(%rdi), %xmm5
	movaps	352(%rdi), %xmm6
	movaps	368(%rdi), %xmm7
	movaps	384(%rdi), %xmm8
	movaps	400(%rdi), %xmm9
	movaps	416(%rdi), %xmm10
	movaps	432(%rdi), %xmm11
	movaps	448(%rdi), %xmm12
	movaps	464(%rdi), %xmm13
	movaps	480(%rdi), %xmm14
	movaps	496(%rdi), %xmm15
	movaps	512(%rdi), %xmm0
	movaps	528(%rdi), %xmm1
	movaps	544(%rdi), %xmm2
	movaps	560(%rdi), %xmm3
	movaps	576(%rdi), %xmm4
	movaps	592(%rdi), %xmm5
	movaps	608(%rdi), %xmm6
	movaps	624(%rdi), %xmm7
	movaps	640(%rdi), %xmm8
	movaps	656(%rdi), %xmm9
	movaps	672(%rdi), %xmm10
	movaps	688(%rdi), %xmm11
	movaps	704(%rdi), %xmm12
	movaps	720(%rdi), %xmm13
	movaps	736(%rdi), %xmm14
	movaps	752(%rdi), %xmm15
	movaps	768(%rdi), %xmm0
	movaps	784(%rdi), %xmm1
	movaps	800(%rdi), %xmm2
	movaps	816(%rdi), %xmm3
	movaps	832(%rdi), %xmm4
	movaps	848(%rdi), %xmm5
	movaps	864(%rdi), %xmm6
	movaps	880(%rdi), %xmm7
	movaps	896(%rdi), %xmm8
	movaps	912(%rdi), %xmm9
	movaps	928(%rdi), %xmm10
	movaps	944(%rdi), %xmm11
	movaps	960(%rdi), %xmm12
	movaps	976(%rdi), %xmm13
	movaps	992(%rdi), %xmm14
	movaps	1008(%rdi), %xmm15
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainrd

	movq	%r12, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainrd

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret
