/*
**  SSEmark benchmarks for RAMspeed (amd64, malloc()-friendly)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2005 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

/* NOTE: this code has been derived from the original SSEmark code, but it
 * contains work-arounds against badly written malloc() functions, which
 * return addresses not aligned at 16-byte boundaries, thus causing the
 * original code to fail with a segmentation fault most likely; the GNU C
 * library of different versions shows such an ignorant behaviour - PVB */

.globl ssewr
ssewr:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	$1024, %rax
	xorps	%xmm0, %xmm0
.mainwr:
	movups	%xmm0, 0(%rdi)
	movups	%xmm0, 16(%rdi)
	movups	%xmm0, 32(%rdi)
	movups	%xmm0, 48(%rdi)
	movups	%xmm0, 64(%rdi)
	movups	%xmm0, 80(%rdi)
	movups	%xmm0, 96(%rdi)
	movups	%xmm0, 112(%rdi)
	movups	%xmm0, 128(%rdi)
	movups	%xmm0, 144(%rdi)
	movups	%xmm0, 160(%rdi)
	movups	%xmm0, 176(%rdi)
	movups	%xmm0, 192(%rdi)
	movups	%xmm0, 208(%rdi)
	movups	%xmm0, 224(%rdi)
	movups	%xmm0, 240(%rdi)
	movups	%xmm0, 256(%rdi)
	movups	%xmm0, 272(%rdi)
	movups	%xmm0, 288(%rdi)
	movups	%xmm0, 304(%rdi)
	movups	%xmm0, 320(%rdi)
	movups	%xmm0, 336(%rdi)
	movups	%xmm0, 352(%rdi)
	movups	%xmm0, 368(%rdi)
	movups	%xmm0, 384(%rdi)
	movups	%xmm0, 400(%rdi)
	movups	%xmm0, 416(%rdi)
	movups	%xmm0, 432(%rdi)
	movups	%xmm0, 448(%rdi)
	movups	%xmm0, 464(%rdi)
	movups	%xmm0, 480(%rdi)
	movups	%xmm0, 496(%rdi)
	movups	%xmm0, 512(%rdi)
	movups	%xmm0, 528(%rdi)
	movups	%xmm0, 544(%rdi)
	movups	%xmm0, 560(%rdi)
	movups	%xmm0, 576(%rdi)
	movups	%xmm0, 592(%rdi)
	movups	%xmm0, 608(%rdi)
	movups	%xmm0, 624(%rdi)
	movups	%xmm0, 640(%rdi)
	movups	%xmm0, 656(%rdi)
	movups	%xmm0, 672(%rdi)
	movups	%xmm0, 688(%rdi)
	movups	%xmm0, 704(%rdi)
	movups	%xmm0, 720(%rdi)
	movups	%xmm0, 736(%rdi)
	movups	%xmm0, 752(%rdi)
	movups	%xmm0, 768(%rdi)
	movups	%xmm0, 784(%rdi)
	movups	%xmm0, 800(%rdi)
	movups	%xmm0, 816(%rdi)
	movups	%xmm0, 832(%rdi)
	movups	%xmm0, 848(%rdi)
	movups	%xmm0, 864(%rdi)
	movups	%xmm0, 880(%rdi)
	movups	%xmm0, 896(%rdi)
	movups	%xmm0, 912(%rdi)
	movups	%xmm0, 928(%rdi)
	movups	%xmm0, 944(%rdi)
	movups	%xmm0, 960(%rdi)
	movups	%xmm0, 976(%rdi)
	movups	%xmm0, 992(%rdi)
	movups	%xmm0, 1008(%rdi)
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainwr

	movq	%r12, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainwr

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl sserd
sserd:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* save the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* prefill */
	movq	%rbx, %rcx
	shlq	$4, %rcx
	xorps	%xmm0, %xmm0
.prerd:
	movups	%xmm0, 0(%rax)
	movups	%xmm0, 16(%rax)
	movups	%xmm0, 32(%rax)
	movups	%xmm0, 48(%rax)
	addq	$64, %rax
	loopq	.prerd
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	$1024, %rax
.mainrd:
	movups	0(%rdi), %xmm0
	movups	16(%rdi), %xmm1
	movups	32(%rdi), %xmm2
	movups	48(%rdi), %xmm3
	movups	64(%rdi), %xmm4
	movups	80(%rdi), %xmm5
	movups	96(%rdi), %xmm6
	movups	112(%rdi), %xmm7
	movups	128(%rdi), %xmm8
	movups	144(%rdi), %xmm9
	movups	160(%rdi), %xmm10
	movups	176(%rdi), %xmm11
	movups	192(%rdi), %xmm12
	movups	208(%rdi), %xmm13
	movups	224(%rdi), %xmm14
	movups	240(%rdi), %xmm15
	movups	256(%rdi), %xmm0
	movups	272(%rdi), %xmm1
	movups	288(%rdi), %xmm2
	movups	304(%rdi), %xmm3
	movups	320(%rdi), %xmm4
	movups	336(%rdi), %xmm5
	movups	352(%rdi), %xmm6
	movups	368(%rdi), %xmm7
	movups	384(%rdi), %xmm8
	movups	400(%rdi), %xmm9
	movups	416(%rdi), %xmm10
	movups	432(%rdi), %xmm11
	movups	448(%rdi), %xmm12
	movups	464(%rdi), %xmm13
	movups	480(%rdi), %xmm14
	movups	496(%rdi), %xmm15
	movups	512(%rdi), %xmm0
	movups	528(%rdi), %xmm1
	movups	544(%rdi), %xmm2
	movups	560(%rdi), %xmm3
	movups	576(%rdi), %xmm4
	movups	592(%rdi), %xmm5
	movups	608(%rdi), %xmm6
	movups	624(%rdi), %xmm7
	movups	640(%rdi), %xmm8
	movups	656(%rdi), %xmm9
	movups	672(%rdi), %xmm10
	movups	688(%rdi), %xmm11
	movups	704(%rdi), %xmm12
	movups	720(%rdi), %xmm13
	movups	736(%rdi), %xmm14
	movups	752(%rdi), %xmm15
	movups	768(%rdi), %xmm0
	movups	784(%rdi), %xmm1
	movups	800(%rdi), %xmm2
	movups	816(%rdi), %xmm3
	movups	832(%rdi), %xmm4
	movups	848(%rdi), %xmm5
	movups	864(%rdi), %xmm6
	movups	880(%rdi), %xmm7
	movups	896(%rdi), %xmm8
	movups	912(%rdi), %xmm9
	movups	928(%rdi), %xmm10
	movups	944(%rdi), %xmm11
	movups	960(%rdi), %xmm12
	movups	976(%rdi), %xmm13
	movups	992(%rdi), %xmm14
	movups	1008(%rdi), %xmm15
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainrd

	movq	%r12, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainrd

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret
