/*
**  SSEmem benchmarks for RAMspeed (amd64)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2005 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

.globl ssecp
ssecp:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rdi
	finit
	fldpi
.precp:
	fst	0(%rdi)
	fst	4(%rdi)
	fst	8(%rdi)
	fst	12(%rdi)
	addq	$16, %rdi
	loopq	.precp
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	$512, %rax
.maincp:
	movaps	0(%rdi), %xmm0
	movaps	16(%rdi), %xmm1
	movaps	32(%rdi), %xmm2
	movaps	48(%rdi), %xmm3
	movaps	64(%rdi), %xmm4
	movaps	80(%rdi), %xmm5
	movaps	96(%rdi), %xmm6
	movaps	112(%rdi), %xmm7
	movaps	%xmm0, 0(%rsi)
	movaps	%xmm1, 16(%rsi)
	movaps	%xmm2, 32(%rsi)
	movaps	%xmm3, 48(%rsi)
	movaps	%xmm4, 64(%rsi)
	movaps	%xmm5, 80(%rsi)
	movaps	%xmm6, 96(%rsi)
	movaps	%xmm7, 112(%rsi)
	movaps	128(%rdi), %xmm0
	movaps	144(%rdi), %xmm1
	movaps	160(%rdi), %xmm2
	movaps	176(%rdi), %xmm3
	movaps	192(%rdi), %xmm4
	movaps	208(%rdi), %xmm5
	movaps	224(%rdi), %xmm6
	movaps	240(%rdi), %xmm7
	movaps	%xmm0, 128(%rsi)
	movaps	%xmm1, 144(%rsi)
	movaps	%xmm2, 160(%rsi)
	movaps	%xmm3, 176(%rsi)
	movaps	%xmm4, 192(%rsi)
	movaps	%xmm5, 208(%rsi)
	movaps	%xmm6, 224(%rsi)
	movaps	%xmm7, 240(%rsi)
	movaps	256(%rdi), %xmm0
	movaps	272(%rdi), %xmm1
	movaps	288(%rdi), %xmm2
	movaps	304(%rdi), %xmm3
	movaps	320(%rdi), %xmm4
	movaps	336(%rdi), %xmm5
	movaps	352(%rdi), %xmm6
	movaps	368(%rdi), %xmm7
	movaps	%xmm0, 256(%rsi)
	movaps	%xmm1, 272(%rsi)
	movaps	%xmm2, 288(%rsi)
	movaps	%xmm3, 304(%rsi)
	movaps	%xmm4, 320(%rsi)
	movaps	%xmm5, 336(%rsi)
	movaps	%xmm6, 352(%rsi)
	movaps	%xmm7, 368(%rsi)
	movaps	384(%rdi), %xmm0
	movaps	400(%rdi), %xmm1
	movaps	416(%rdi), %xmm2
	movaps	432(%rdi), %xmm3
	movaps	448(%rdi), %xmm4
	movaps	464(%rdi), %xmm5
	movaps	480(%rdi), %xmm6
	movaps	496(%rdi), %xmm7
	movaps	%xmm0, 384(%rsi)
	movaps	%xmm1, 400(%rsi)
	movaps	%xmm2, 416(%rsi)
	movaps	%xmm3, 432(%rsi)
	movaps	%xmm4, 448(%rsi)
	movaps	%xmm5, 464(%rsi)
	movaps	%xmm6, 480(%rsi)
	movaps	%xmm7, 496(%rsi)
	addq	%rax, %rdi
	addq	%rax, %rsi
	decq	%rcx
	jnz	.maincp

	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.maincp

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssesc
ssesc:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rdi
	finit
	fldpi
.presc:
	fst	0(%rdi)
	fst	4(%rdi)
	fst	8(%rdi)
	fst	12(%rdi)
	addq	$16, %rdi
	loopq	.presc
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	16(%rsp)
	fst	20(%rsp)
	movlps	16(%rsp), %xmm8
	movlhps	%xmm8, %xmm8
	ffree	%st(0)
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	$512, %rax
.mainsc:
	movaps	0(%rdi), %xmm0
	movaps	16(%rdi), %xmm1
	movaps	32(%rdi), %xmm2
	movaps	48(%rdi), %xmm3
	movaps	64(%rdi), %xmm4
	movaps	80(%rdi), %xmm5
	movaps	96(%rdi), %xmm6
	movaps	112(%rdi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movaps	%xmm0, 0(%rsi)
	movaps	%xmm1, 16(%rsi)
	movaps	%xmm2, 32(%rsi)
	movaps	%xmm3, 48(%rsi)
	movaps	%xmm4, 64(%rsi)
	movaps	%xmm5, 80(%rsi)
	movaps	%xmm6, 96(%rsi)
	movaps	%xmm7, 112(%rsi)
	movaps	128(%rdi), %xmm0
	movaps	144(%rdi), %xmm1
	movaps	160(%rdi), %xmm2
	movaps	176(%rdi), %xmm3
	movaps	192(%rdi), %xmm4
	movaps	208(%rdi), %xmm5
	movaps	224(%rdi), %xmm6
	movaps	240(%rdi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movaps	%xmm0, 128(%rsi)
	movaps	%xmm1, 144(%rsi)
	movaps	%xmm2, 160(%rsi)
	movaps	%xmm3, 176(%rsi)
	movaps	%xmm4, 192(%rsi)
	movaps	%xmm5, 208(%rsi)
	movaps	%xmm6, 224(%rsi)
	movaps	%xmm7, 240(%rsi)
	movaps	256(%rdi), %xmm0
	movaps	272(%rdi), %xmm1
	movaps	288(%rdi), %xmm2
	movaps	304(%rdi), %xmm3
	movaps	320(%rdi), %xmm4
	movaps	336(%rdi), %xmm5
	movaps	352(%rdi), %xmm6
	movaps	368(%rdi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movaps	%xmm0, 256(%rsi)
	movaps	%xmm1, 272(%rsi)
	movaps	%xmm2, 288(%rsi)
	movaps	%xmm3, 304(%rsi)
	movaps	%xmm4, 320(%rsi)
	movaps	%xmm5, 336(%rsi)
	movaps	%xmm6, 352(%rsi)
	movaps	%xmm7, 368(%rsi)
	movaps	384(%rdi), %xmm0
	movaps	400(%rdi), %xmm1
	movaps	416(%rdi), %xmm2
	movaps	432(%rdi), %xmm3
	movaps	448(%rdi), %xmm4
	movaps	464(%rdi), %xmm5
	movaps	480(%rdi), %xmm6
	movaps	496(%rdi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movaps	%xmm0, 384(%rsi)
	movaps	%xmm1, 400(%rsi)
	movaps	%xmm2, 416(%rsi)
	movaps	%xmm3, 432(%rsi)
	movaps	%xmm4, 448(%rsi)
	movaps	%xmm5, 464(%rsi)
	movaps	%xmm6, 480(%rsi)
	movaps	%xmm7, 496(%rsi)
	addq	%rax, %rdi
	addq	%rax, %rsi
	decq	%rcx
	jnz	.mainsc

	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainsc

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssead
ssead:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
	finit
	fldpi
.pread:
	fst	0(%rdi)
	fst	4(%rdi)
	fst	8(%rdi)
	fst	12(%rdi)
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	addq	$16, %rdi
	addq	$16, %rsi
	loopq	.pread
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%r14, %rbp
	movq	$512, %rax
.mainad:
	movaps	0(%rdi), %xmm0
	movaps	16(%rdi), %xmm1
	movaps	32(%rdi), %xmm2
	movaps	48(%rdi), %xmm3
	movaps	64(%rdi), %xmm4
	movaps	80(%rdi), %xmm5
	movaps	96(%rdi), %xmm6
	movaps	112(%rdi), %xmm7
	addps	0(%rsi), %xmm0
	addps	16(%rsi), %xmm1
	addps	32(%rsi), %xmm2
	addps	48(%rsi), %xmm3
	addps	64(%rsi), %xmm4
	addps	80(%rsi), %xmm5
	addps	96(%rsi), %xmm6
	addps	112(%rsi), %xmm7
	movaps	%xmm0, 0(%rbp)
	movaps	%xmm1, 16(%rbp)
	movaps	%xmm2, 32(%rbp)
	movaps	%xmm3, 48(%rbp)
	movaps	%xmm4, 64(%rbp)
	movaps	%xmm5, 80(%rbp)
	movaps	%xmm6, 96(%rbp)
	movaps	%xmm7, 112(%rbp)
	movaps	128(%rdi), %xmm0
	movaps	144(%rdi), %xmm1
	movaps	160(%rdi), %xmm2
	movaps	176(%rdi), %xmm3
	movaps	192(%rdi), %xmm4
	movaps	208(%rdi), %xmm5
	movaps	224(%rdi), %xmm6
	movaps	240(%rdi), %xmm7
	addps	128(%rsi), %xmm0
	addps	144(%rsi), %xmm1
	addps	160(%rsi), %xmm2
	addps	176(%rsi), %xmm3
	addps	192(%rsi), %xmm4
	addps	208(%rsi), %xmm5
	addps	224(%rsi), %xmm6
	addps	240(%rsi), %xmm7
	movaps	%xmm0, 128(%rbp)
	movaps	%xmm1, 144(%rbp)
	movaps	%xmm2, 160(%rbp)
	movaps	%xmm3, 176(%rbp)
	movaps	%xmm4, 192(%rbp)
	movaps	%xmm5, 208(%rbp)
	movaps	%xmm6, 224(%rbp)
	movaps	%xmm7, 240(%rbp)
	movaps	256(%rdi), %xmm0
	movaps	272(%rdi), %xmm1
	movaps	288(%rdi), %xmm2
	movaps	304(%rdi), %xmm3
	movaps	320(%rdi), %xmm4
	movaps	336(%rdi), %xmm5
	movaps	352(%rdi), %xmm6
	movaps	368(%rdi), %xmm7
	addps	256(%rsi), %xmm0
	addps	272(%rsi), %xmm1
	addps	288(%rsi), %xmm2
	addps	304(%rsi), %xmm3
	addps	320(%rsi), %xmm4
	addps	336(%rsi), %xmm5
	addps	352(%rsi), %xmm6
	addps	368(%rsi), %xmm7
	movaps	%xmm0, 256(%rbp)
	movaps	%xmm1, 272(%rbp)
	movaps	%xmm2, 288(%rbp)
	movaps	%xmm3, 304(%rbp)
	movaps	%xmm4, 320(%rbp)
	movaps	%xmm5, 336(%rbp)
	movaps	%xmm6, 352(%rbp)
	movaps	%xmm7, 368(%rbp)
	movaps	384(%rdi), %xmm0
	movaps	400(%rdi), %xmm1
	movaps	416(%rdi), %xmm2
	movaps	432(%rdi), %xmm3
	movaps	448(%rdi), %xmm4
	movaps	464(%rdi), %xmm5
	movaps	480(%rdi), %xmm6
	movaps	496(%rdi), %xmm7
	addps	384(%rsi), %xmm0
	addps	400(%rsi), %xmm1
	addps	416(%rsi), %xmm2
	addps	432(%rsi), %xmm3
	addps	448(%rsi), %xmm4
	addps	464(%rsi), %xmm5
	addps	480(%rsi), %xmm6
	addps	496(%rsi), %xmm7
	movaps	%xmm0, 384(%rbp)
	movaps	%xmm1, 400(%rbp)
	movaps	%xmm2, 416(%rbp)
	movaps	%xmm3, 432(%rbp)
	movaps	%xmm4, 448(%rbp)
	movaps	%xmm5, 464(%rbp)
	movaps	%xmm6, 480(%rbp)
	movaps	%xmm7, 496(%rbp)
	addq	%rax, %rdi
	addq	%rax, %rsi
	addq	%rax, %rbp
	decq	%rcx
	jnz	.mainad

	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%r14, %rbp
	movq	%rbx, %rcx
	decq	%r15
	jnz	.mainad

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssetr
ssetr:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
	finit
	fldpi
.pretr:
	fst	0(%rdi)
	fst	4(%rdi)
	fst	8(%rdi)
	fst	12(%rdi)
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	addq	$16, %rdi
	addq	$16, %rsi
	loopq	.pretr
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	16(%rsp)
	fst	20(%rsp)
	movlps	16(%rsp), %xmm8
	movlhps	%xmm8, %xmm8
	ffree	%st(0)
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%r14, %rbp
	movq	$512, %rax
.maintr:
	movaps	0(%rsi), %xmm0
	movaps	16(%rsi), %xmm1
	movaps	32(%rsi), %xmm2
	movaps	48(%rsi), %xmm3
	movaps	64(%rsi), %xmm4
	movaps	80(%rsi), %xmm5
	movaps	96(%rsi), %xmm6
	movaps	112(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	0(%rdi), %xmm0
	addps	16(%rdi), %xmm1
	addps	32(%rdi), %xmm2
	addps	48(%rdi), %xmm3
	addps	64(%rdi), %xmm4
	addps	80(%rdi), %xmm5
	addps	96(%rdi), %xmm6
	addps	112(%rdi), %xmm7
	movaps	%xmm0, 0(%rbp)
	movaps	%xmm1, 16(%rbp)
	movaps	%xmm2, 32(%rbp)
	movaps	%xmm3, 48(%rbp)
	movaps	%xmm4, 64(%rbp)
	movaps	%xmm5, 80(%rbp)
	movaps	%xmm6, 96(%rbp)
	movaps	%xmm7, 112(%rbp)
	movaps	128(%rsi), %xmm0
	movaps	144(%rsi), %xmm1
	movaps	160(%rsi), %xmm2
	movaps	176(%rsi), %xmm3
	movaps	192(%rsi), %xmm4
	movaps	208(%rsi), %xmm5
	movaps	224(%rsi), %xmm6
	movaps	240(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	128(%rdi), %xmm0
	addps	144(%rdi), %xmm1
	addps	160(%rdi), %xmm2
	addps	176(%rdi), %xmm3
	addps	192(%rdi), %xmm4
	addps	208(%rdi), %xmm5
	addps	224(%rdi), %xmm6
	addps	240(%rdi), %xmm7
	movaps	%xmm0, 128(%rbp)
	movaps	%xmm1, 144(%rbp)
	movaps	%xmm2, 160(%rbp)
	movaps	%xmm3, 176(%rbp)
	movaps	%xmm4, 192(%rbp)
	movaps	%xmm5, 208(%rbp)
	movaps	%xmm6, 224(%rbp)
	movaps	%xmm7, 240(%rbp)
	movaps	256(%rsi), %xmm0
	movaps	272(%rsi), %xmm1
	movaps	288(%rsi), %xmm2
	movaps	304(%rsi), %xmm3
	movaps	320(%rsi), %xmm4
	movaps	336(%rsi), %xmm5
	movaps	352(%rsi), %xmm6
	movaps	368(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	256(%rdi), %xmm0
	addps	272(%rdi), %xmm1
	addps	288(%rdi), %xmm2
	addps	304(%rdi), %xmm3
	addps	320(%rdi), %xmm4
	addps	336(%rdi), %xmm5
	addps	352(%rdi), %xmm6
	addps	368(%rdi), %xmm7
	movaps	%xmm0, 256(%rbp)
	movaps	%xmm1, 272(%rbp)
	movaps	%xmm2, 288(%rbp)
	movaps	%xmm3, 304(%rbp)
	movaps	%xmm4, 320(%rbp)
	movaps	%xmm5, 336(%rbp)
	movaps	%xmm6, 352(%rbp)
	movaps	%xmm7, 368(%rbp)
	movaps	384(%rsi), %xmm0
	movaps	400(%rsi), %xmm1
	movaps	416(%rsi), %xmm2
	movaps	432(%rsi), %xmm3
	movaps	448(%rsi), %xmm4
	movaps	464(%rsi), %xmm5
	movaps	480(%rsi), %xmm6
	movaps	496(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	384(%rdi), %xmm0
	addps	400(%rdi), %xmm1
	addps	416(%rdi), %xmm2
	addps	432(%rdi), %xmm3
	addps	448(%rdi), %xmm4
	addps	464(%rdi), %xmm5
	addps	480(%rdi), %xmm6
	addps	496(%rdi), %xmm7
	movaps	%xmm0, 384(%rbp)
	movaps	%xmm1, 400(%rbp)
	movaps	%xmm2, 416(%rbp)
	movaps	%xmm3, 432(%rbp)
	movaps	%xmm4, 448(%rbp)
	movaps	%xmm5, 464(%rbp)
	movaps	%xmm6, 480(%rbp)
	movaps	%xmm7, 496(%rbp)
	addq	%rax, %rdi
	addq	%rax, %rsi
	addq	%rax, %rbp
	decq	%rcx
	jnz	.maintr

	movq	%r12, %rdi
	movq	%r13, %rsi
	movq	%r14, %rbp
	movq	%rbx, %rcx
	decq	%r15
	jnz	.maintr

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret
