/*
**  MMXmem benchmarks for RAMspeed (i386)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2004-05 Rhett M. Hollander <rhett@alasir.com>
**
**  All rights reserved.
**
*/

.globl  mmxcp
mmxcp:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	shrl	$3, %ecx
.precp:
	movw	$33, 0(%edx)
	movw	$33, 2(%edx)
	movw	$33, 4(%edx)
	movw	$33, 6(%edx)
	addl	$8, %edx
	loopl	.precp
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* execute */
	shrl	$8, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.maincp:
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	movq	%mm0, 0(%edi)
	movq	%mm1, 8(%edi)
	movq	%mm2, 16(%edi)
	movq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	movq	%mm0, 32(%edi)
	movq	%mm1, 40(%edi)
	movq	%mm2, 48(%edi)
	movq	%mm3, 56(%edi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	movq	%mm0, 64(%edi)
	movq	%mm1, 72(%edi)
	movq	%mm2, 80(%edi)
	movq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	movq	%mm0, 96(%edi)
	movq	%mm1, 104(%edi)
	movq	%mm2, 112(%edi)
	movq	%mm3, 120(%edi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	movq	%mm0, 128(%edi)
	movq	%mm1, 136(%edi)
	movq	%mm2, 144(%edi)
	movq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	movq	%mm0, 160(%edi)
	movq	%mm1, 168(%edi)
	movq	%mm2, 176(%edi)
	movq	%mm3, 184(%edi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	movq	%mm0, 192(%edi)
	movq	%mm1, 200(%edi)
	movq	%mm2, 208(%edi)
	movq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	movq	%mm0, 224(%edi)
	movq	%mm1, 232(%edi)
	movq	%mm2, 240(%edi)
	movq	%mm3, 248(%edi)
	addl	$256, %esi
	addl	$256, %edi
	decl	%ebx
	jnz	.maincp

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.maincp

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  mmxsc
mmxsc:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	shrl	$3, %ecx
.presc:
	movw	$33, 0(%edx)
	movw	$33, 2(%edx)
	movw	$33, 4(%edx)
	movw	$33, 6(%edx)
	addl	$8, %edx
	loopl	.presc
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* create the multiplier */
	movw	$77, 8(%esp)
	movw	$77, 10(%esp)
	movw	$77, 12(%esp)
	movw	$77, 14(%esp)
	movq	8(%esp), %mm4
/* execute */
	shrl	$8, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.mainsc:
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 0(%edi)
	movq	%mm1, 8(%edi)
	movq	%mm2, 16(%edi)
	movq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 32(%edi)
	movq	%mm1, 40(%edi)
	movq	%mm2, 48(%edi)
	movq	%mm3, 56(%edi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 64(%edi)
	movq	%mm1, 72(%edi)
	movq	%mm2, 80(%edi)
	movq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 96(%edi)
	movq	%mm1, 104(%edi)
	movq	%mm2, 112(%edi)
	movq	%mm3, 120(%edi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 128(%edi)
	movq	%mm1, 136(%edi)
	movq	%mm2, 144(%edi)
	movq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 160(%edi)
	movq	%mm1, 168(%edi)
	movq	%mm2, 176(%edi)
	movq	%mm3, 184(%edi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 192(%edi)
	movq	%mm1, 200(%edi)
	movq	%mm2, 208(%edi)
	movq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 224(%edi)
	movq	%mm1, 232(%edi)
	movq	%mm2, 240(%edi)
	movq	%mm3, 248(%edi)
	addl	$256, %esi
	addl	$256, %edi
	decl	%ebx
	jnz	.mainsc

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.mainsc

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  mmxad
mmxad:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %ebp
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
	shrl	$3, %ecx
.pread:
	movw	$33, 0(%edx)
	movw	$33, 2(%edx)
	movw	$33, 4(%edx)
	movw	$33, 6(%edx)
	movw	$55, 0(%eax)
	movw	$55, 2(%eax)
	movw	$55, 4(%eax)
	movw	$55, 6(%eax)
	addl	$8, %edx
	addl	$8, %eax
	loopl	.pread
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* execute */
	shrl	$8, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$256, %edx
.mainad:
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	paddusw	0(%ebp), %mm0
	paddusw	8(%ebp), %mm1
	paddusw	16(%ebp), %mm2
	paddusw	24(%ebp), %mm3
	movq	%mm0, 0(%edi)
	movq	%mm1, 8(%edi)
	movq	%mm2, 16(%edi)
	movq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	54(%esi), %mm3
	paddusw	32(%ebp), %mm0
	paddusw	40(%ebp), %mm1
	paddusw	48(%ebp), %mm2
	paddusw	54(%ebp), %mm3
	movq	%mm0, 32(%edi)
	movq	%mm1, 40(%edi)
	movq	%mm2, 48(%edi)
	movq	%mm3, 54(%edi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	paddusw	64(%ebp), %mm0
	paddusw	72(%ebp), %mm1
	paddusw	80(%ebp), %mm2
	paddusw	88(%ebp), %mm3
	movq	%mm0, 64(%edi)
	movq	%mm1, 72(%edi)
	movq	%mm2, 80(%edi)
	movq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	paddusw	96(%ebp), %mm0
	paddusw	104(%ebp), %mm1
	paddusw	112(%ebp), %mm2
	paddusw	120(%ebp), %mm3
	movq	%mm0, 96(%edi)
	movq	%mm1, 104(%edi)
	movq	%mm2, 112(%edi)
	movq	%mm3, 120(%edi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	paddusw	128(%ebp), %mm0
	paddusw	136(%ebp), %mm1
	paddusw	144(%ebp), %mm2
	paddusw	152(%ebp), %mm3
	movq	%mm0, 128(%edi)
	movq	%mm1, 136(%edi)
	movq	%mm2, 144(%edi)
	movq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	paddusw	160(%ebp), %mm0
	paddusw	168(%ebp), %mm1
	paddusw	176(%ebp), %mm2
	paddusw	184(%ebp), %mm3
	movq	%mm0, 160(%edi)
	movq	%mm1, 168(%edi)
	movq	%mm2, 176(%edi)
	movq	%mm3, 184(%edi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	paddusw	192(%ebp), %mm0
	paddusw	200(%ebp), %mm1
	paddusw	208(%ebp), %mm2
	paddusw	216(%ebp), %mm3
	movq	%mm0, 192(%edi)
	movq	%mm1, 200(%edi)
	movq	%mm2, 208(%edi)
	movq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	paddusw	224(%ebp), %mm0
	paddusw	232(%ebp), %mm1
	paddusw	240(%ebp), %mm2
	paddusw	248(%ebp), %mm3
	movq	%mm0, 224(%edi)
	movq	%mm1, 232(%edi)
	movq	%mm2, 240(%edi)
	movq	%mm3, 248(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.mainad

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.mainad

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%ebp, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  mmxtr
mmxtr:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %ebp
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
	shrl	$3, %ecx
.pretr:
	movw	$33, 0(%edx)
	movw	$33, 2(%edx)
	movw	$33, 4(%edx)
	movw	$33, 6(%edx)
	movw	$55, 0(%eax)
	movw	$55, 2(%eax)
	movw	$55, 4(%eax)
	movw	$55, 6(%eax)
	addl	$8, %edx
	addl	$8, %eax
	loopl	.pretr
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* create the multiplier */
	movw	$77, 8(%esp)
	movw	$77, 10(%esp)
	movw	$77, 12(%esp)
	movw	$77, 14(%esp)
	movq	8(%esp), %mm4
/* execute */
	shrl	$8, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$256, %edx
.maintr:
	movq	0(%ebp), %mm0
	movq	8(%ebp), %mm1
	movq	16(%ebp), %mm2
	movq	24(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	0(%esi), %mm0
	paddusw	8(%esi), %mm1
	paddusw	16(%esi), %mm2
	paddusw	24(%esi), %mm3
	movq	%mm0, 0(%edi)
	movq	%mm1, 8(%edi)
	movq	%mm2, 16(%edi)
	movq	%mm3, 24(%edi)
	movq	32(%ebp), %mm0
	movq	40(%ebp), %mm1
	movq	48(%ebp), %mm2
	movq	56(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	32(%esi), %mm0
	paddusw	40(%esi), %mm1
	paddusw	48(%esi), %mm2
	paddusw	56(%esi), %mm3
	movq	%mm0, 32(%edi)
	movq	%mm1, 40(%edi)
	movq	%mm2, 48(%edi)
	movq	%mm3, 56(%edi)
	movq	64(%ebp), %mm0
	movq	72(%ebp), %mm1
	movq	80(%ebp), %mm2
	movq	88(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	64(%esi), %mm0
	paddusw	72(%esi), %mm1
	paddusw	80(%esi), %mm2
	paddusw	88(%esi), %mm3
	movq	%mm0, 64(%edi)
	movq	%mm1, 72(%edi)
	movq	%mm2, 80(%edi)
	movq	%mm3, 88(%edi)
	movq	96(%ebp), %mm0
	movq	104(%ebp), %mm1
	movq	112(%ebp), %mm2
	movq	120(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	96(%esi), %mm0
	paddusw	104(%esi), %mm1
	paddusw	112(%esi), %mm2
	paddusw	120(%esi), %mm3
	movq	%mm0, 96(%edi)
	movq	%mm1, 104(%edi)
	movq	%mm2, 112(%edi)
	movq	%mm3, 120(%edi)
	movq	128(%ebp), %mm0
	movq	136(%ebp), %mm1
	movq	144(%ebp), %mm2
	movq	152(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	128(%esi), %mm0
	paddusw	136(%esi), %mm1
	paddusw	144(%esi), %mm2
	paddusw	152(%esi), %mm3
	movq	%mm0, 128(%edi)
	movq	%mm1, 136(%edi)
	movq	%mm2, 144(%edi)
	movq	%mm3, 152(%edi)
	movq	160(%ebp), %mm0
	movq	168(%ebp), %mm1
	movq	176(%ebp), %mm2
	movq	184(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	160(%esi), %mm0
	paddusw	168(%esi), %mm1
	paddusw	176(%esi), %mm2
	paddusw	184(%esi), %mm3
	movq	%mm0, 160(%edi)
	movq	%mm1, 168(%edi)
	movq	%mm2, 176(%edi)
	movq	%mm3, 184(%edi)
	movq	192(%ebp), %mm0
	movq	200(%ebp), %mm1
	movq	208(%ebp), %mm2
	movq	216(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	192(%esi), %mm0
	paddusw	200(%esi), %mm1
	paddusw	208(%esi), %mm2
	paddusw	216(%esi), %mm3
	movq	%mm0, 192(%edi)
	movq	%mm1, 200(%edi)
	movq	%mm2, 208(%edi)
	movq	%mm3, 216(%edi)
	movq	224(%ebp), %mm0
	movq	232(%ebp), %mm1
	movq	240(%ebp), %mm2
	movq	248(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	224(%esi), %mm0
	paddusw	232(%esi), %mm1
	paddusw	240(%esi), %mm2
	paddusw	248(%esi), %mm3
	movq	%mm0, 224(%edi)
	movq	%mm1, 232(%edi)
	movq	%mm2, 240(%edi)
	movq	%mm3, 248(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.maintr

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.maintr

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%ebp, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret
