/*
**  SSEmark benchmarks for RAMspeed (i386, malloc()-friendly)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2004-05 Rhett M. Hollander <rhett@alasir.com>
**  Copyright (c) 2005 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

/* NOTE: this code has been derived from the original SSEmark code, but it
 * contains work-arounds against badly written malloc() functions, which
 * return addresses not aligned at 16-byte boundaries, thus causing the
 * original code to fail with a segmentation fault most likely; the GNU C
 * library of different versions shows such an ignorant behaviour - PVB */

.globl  ssewr
ssewr:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %edi
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* execute */
	shrl	$10, %ebx
	movl	%ebx, %ebp
	movl	%edi, %esi
	movl	72(%esp), %ecx
	movl	$1024, %eax
	xorps	%xmm0, %xmm0
.mainwr:
	movups	%xmm0, 0(%edi)
	movups	%xmm0, 16(%edi)
	movups	%xmm0, 32(%edi)
	movups	%xmm0, 48(%edi)
	movups	%xmm0, 64(%edi)
	movups	%xmm0, 80(%edi)
	movups	%xmm0, 96(%edi)
	movups	%xmm0, 112(%edi)
	movups	%xmm0, 128(%edi)
	movups	%xmm0, 144(%edi)
	movups	%xmm0, 160(%edi)
	movups	%xmm0, 176(%edi)
	movups	%xmm0, 192(%edi)
	movups	%xmm0, 208(%edi)
	movups	%xmm0, 224(%edi)
	movups	%xmm0, 240(%edi)
	movups	%xmm0, 256(%edi)
	movups	%xmm0, 272(%edi)
	movups	%xmm0, 288(%edi)
	movups	%xmm0, 304(%edi)
	movups	%xmm0, 320(%edi)
	movups	%xmm0, 336(%edi)
	movups	%xmm0, 352(%edi)
	movups	%xmm0, 368(%edi)
	movups	%xmm0, 384(%edi)
	movups	%xmm0, 400(%edi)
	movups	%xmm0, 416(%edi)
        movups	%xmm0, 432(%edi)
	movups	%xmm0, 448(%edi)
	movups	%xmm0, 464(%edi)
	movups	%xmm0, 480(%edi)
	movups	%xmm0, 496(%edi)
	movups	%xmm0, 512(%edi)
	movups	%xmm0, 528(%edi)
	movups	%xmm0, 544(%edi)
	movups	%xmm0, 560(%edi)
	movups	%xmm0, 576(%edi)
	movups	%xmm0, 592(%edi)
	movups	%xmm0, 608(%edi)
	movups	%xmm0, 624(%edi)
	movups	%xmm0, 640(%edi)
	movups	%xmm0, 656(%edi)
	movups	%xmm0, 672(%edi)
	movups	%xmm0, 688(%edi)
	movups	%xmm0, 704(%edi)
	movups	%xmm0, 720(%edi)
	movups	%xmm0, 736(%edi)
	movups	%xmm0, 752(%edi)
	movups	%xmm0, 768(%edi)
	movups	%xmm0, 784(%edi)
	movups	%xmm0, 800(%edi)
	movups	%xmm0, 816(%edi)
	movups	%xmm0, 832(%edi)
	movups	%xmm0, 848(%edi)
	movups	%xmm0, 864(%edi)
        movups	%xmm0, 880(%edi)
	movups	%xmm0, 896(%edi)
	movups	%xmm0, 912(%edi)
	movups	%xmm0, 928(%edi)
	movups	%xmm0, 944(%edi)
	movups	%xmm0, 960(%edi)
	movups	%xmm0, 976(%edi)
	movups	%xmm0, 992(%edi)
	movups	%xmm0, 1008(%edi)
	addl	%eax, %edi
	decl	%ebx
	jnz	.mainwr

	movl	%ebp, %ebx
	movl	%esi, %edi
	decl	%ecx
	jnz	.mainwr

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  sserd
sserd:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* prefill */
	movl	%ebx, %ecx
	shrl	$6, %ecx
	xorps	%xmm0, %xmm0
.prerd:
	movups	%xmm0, 0(%eax)
	movups	%xmm0, 16(%eax)
	movups	%xmm0, 32(%eax)
	movups	%xmm0, 48(%eax)
	addl	$64, %eax
	loopl	.prerd
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* execute */
	shrl	$10, %ebx
	movl	%ebx, %ebp
	movl	%esi, %edi
	movl	72(%esp), %ecx
	movl	$1024, %eax
.mainrd:
	movups	0(%esi), %xmm0
	movups	16(%esi), %xmm0
	movups	32(%esi), %xmm0
	movups	48(%esi), %xmm0
	movups	64(%esi), %xmm0
	movups	80(%esi), %xmm0
	movups	96(%esi), %xmm0
	movups	112(%esi), %xmm0
	movups	128(%esi), %xmm0
	movups	144(%esi), %xmm0
	movups	160(%esi), %xmm0
	movups	176(%esi), %xmm0
	movups	192(%esi), %xmm0
	movups	208(%esi), %xmm0
	movups	224(%esi), %xmm0
	movups	240(%esi), %xmm0
	movups	256(%esi), %xmm0
	movups	272(%esi), %xmm0
	movups	288(%esi), %xmm0
	movups	304(%esi), %xmm0
	movups	320(%esi), %xmm0
	movups	336(%esi), %xmm0
	movups	352(%esi), %xmm0
	movups	368(%esi), %xmm0
	movups	384(%esi), %xmm0
	movups	400(%esi), %xmm0
	movups	416(%esi), %xmm0
        movups	432(%esi), %xmm0
	movups	448(%esi), %xmm0
	movups	464(%esi), %xmm0
	movups	480(%esi), %xmm0
	movups	496(%esi), %xmm0
	movups	512(%esi), %xmm0
	movups	528(%esi), %xmm0
	movups	544(%esi), %xmm0
	movups	560(%esi), %xmm0
	movups	576(%esi), %xmm0
	movups	592(%esi), %xmm0
	movups	608(%esi), %xmm0
	movups	624(%esi), %xmm0
	movups	640(%esi), %xmm0
	movups	656(%esi), %xmm0
	movups	672(%esi), %xmm0
	movups	688(%esi), %xmm0
	movups	704(%esi), %xmm0
	movups	720(%esi), %xmm0
	movups	736(%esi), %xmm0
	movups	752(%esi), %xmm0
	movups	768(%esi), %xmm0
	movups	784(%esi), %xmm0
	movups	800(%esi), %xmm0
	movups	816(%esi), %xmm0
	movups	832(%esi), %xmm0
	movups	848(%esi), %xmm0
	movups	864(%esi), %xmm0
        movups	880(%esi), %xmm0
	movups	896(%esi), %xmm0
	movups	912(%esi), %xmm0
	movups	928(%esi), %xmm0
	movups	944(%esi), %xmm0
	movups	960(%esi), %xmm0
	movups	976(%esi), %xmm0
	movups	992(%esi), %xmm0
	movups	1008(%esi), %xmm0
	addl	%eax, %esi
	decl	%ebx
	jnz	.mainrd

	movl	%ebp, %ebx
	movl	%edi, %esi
	decl	%ecx
	jnz	.mainrd

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret
