/*
**  SSEmem benchmarks for RAMspeed (i386)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2004-05 Rhett M. Hollander <rhett@alasir.com>
**
**  All rights reserved.
**
*/

.globl  ssecp
ssecp:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	shrl	$4, %ecx
	finit
	fldpi
.precp:
	fst	0(%edx)
	fst	4(%edx)
	fst	8(%edx)
	fst	12(%edx)
	addl	$16, %edx
	loopl	.precp
	ffree	%st(0)
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* execute */
	shrl	$9, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.maincp:
	movaps	0(%esi), %xmm0
	movaps	16(%esi), %xmm1
	movaps	32(%esi), %xmm2
	movaps	48(%esi), %xmm3
	movaps	%xmm0, 0(%edi)
	movaps	%xmm1, 16(%edi)
	movaps	%xmm2, 32(%edi)
	movaps	%xmm3, 48(%edi)
	movaps	64(%esi), %xmm0
	movaps	80(%esi), %xmm1
	movaps	96(%esi), %xmm2
	movaps	112(%esi), %xmm3
	movaps	%xmm0, 64(%edi)
	movaps	%xmm1, 80(%edi)
	movaps	%xmm2, 96(%edi)
	movaps	%xmm3, 112(%edi)
	movaps	128(%esi), %xmm0
	movaps	144(%esi), %xmm1
	movaps	160(%esi), %xmm2
	movaps	176(%esi), %xmm3
	movaps	%xmm0, 128(%edi)
	movaps	%xmm1, 144(%edi)
	movaps	%xmm2, 160(%edi)
	movaps	%xmm3, 176(%edi)
	movaps	192(%esi), %xmm0
	movaps	208(%esi), %xmm1
	movaps	224(%esi), %xmm2
	movaps	240(%esi), %xmm3
	movaps	%xmm0, 192(%edi)
	movaps	%xmm1, 208(%edi)
	movaps	%xmm2, 224(%edi)
	movaps	%xmm3, 240(%edi)
	movaps	256(%esi), %xmm0
	movaps	272(%esi), %xmm1
	movaps	288(%esi), %xmm2
	movaps	304(%esi), %xmm3
	movaps	%xmm0, 256(%edi)
	movaps	%xmm1, 272(%edi)
	movaps	%xmm2, 288(%edi)
	movaps	%xmm3, 304(%edi)
	movaps	320(%esi), %xmm0
	movaps	336(%esi), %xmm1
	movaps	352(%esi), %xmm2
	movaps	368(%esi), %xmm3
	movaps	%xmm0, 320(%edi)
	movaps	%xmm1, 336(%edi)
	movaps	%xmm2, 352(%edi)
	movaps	%xmm3, 368(%edi)
	movaps	384(%esi), %xmm0
	movaps	400(%esi), %xmm1
	movaps	416(%esi), %xmm2
	movaps	432(%esi), %xmm3
	movaps	%xmm0, 384(%edi)
	movaps	%xmm1, 400(%edi)
	movaps	%xmm2, 416(%edi)
	movaps	%xmm3, 432(%edi)
	movaps	448(%esi), %xmm0
	movaps	464(%esi), %xmm1
	movaps	480(%esi), %xmm2
	movaps	496(%esi), %xmm3
	movaps	%xmm0, 448(%edi)
	movaps	%xmm1, 464(%edi)
	movaps	%xmm2, 480(%edi)
	movaps	%xmm3, 496(%edi)
	addl	$512, %esi
	addl	$512, %edi
	decl	%ebx
	jnz	.maincp

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.maincp

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  ssesc
ssesc:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	shrl	$4, %ecx
	finit
	fldpi
.presc:
	fst	0(%edx)
	fst	4(%edx)
	fst	8(%edx)
	fst	12(%edx)
	addl	$16, %edx
	loopl	.presc
	ffree	%st(0)
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	8(%esp)
	fst	12(%esp)
	fst	16(%esp)
	fst	20(%esp)
	movups	8(%esp), %xmm4
	ffree	%st(0)
/* execute */
	shrl	$9, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.mainsc:
	movaps	0(%esi), %xmm0
	movaps	16(%esi), %xmm1
	movaps	32(%esi), %xmm2
	movaps	48(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movaps	%xmm0, 0(%edi)
	movaps	%xmm1, 16(%edi)
	movaps	%xmm2, 32(%edi)
	movaps	%xmm3, 48(%edi)
	movaps	64(%esi), %xmm0
	movaps	80(%esi), %xmm1
	movaps	96(%esi), %xmm2
	movaps	112(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movaps	%xmm0, 64(%edi)
	movaps	%xmm1, 80(%edi)
	movaps	%xmm2, 96(%edi)
	movaps	%xmm3, 112(%edi)
	movaps	128(%esi), %xmm0
	movaps	144(%esi), %xmm1
	movaps	160(%esi), %xmm2
	movaps	176(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movaps	%xmm0, 128(%edi)
	movaps	%xmm1, 144(%edi)
	movaps	%xmm2, 160(%edi)
	movaps	%xmm3, 176(%edi)
	movaps	192(%esi), %xmm0
	movaps	208(%esi), %xmm1
	movaps	224(%esi), %xmm2
	movaps	240(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movaps	%xmm0, 192(%edi)
	movaps	%xmm1, 208(%edi)
	movaps	%xmm2, 224(%edi)
	movaps	%xmm3, 240(%edi)
	movaps	256(%esi), %xmm0
	movaps	272(%esi), %xmm1
	movaps	288(%esi), %xmm2
	movaps	304(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movaps	%xmm0, 256(%edi)
	movaps	%xmm1, 272(%edi)
	movaps	%xmm2, 288(%edi)
	movaps	%xmm3, 304(%edi)
	movaps	320(%esi), %xmm0
	movaps	336(%esi), %xmm1
	movaps	352(%esi), %xmm2
	movaps	368(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movaps	%xmm0, 320(%edi)
	movaps	%xmm1, 336(%edi)
	movaps	%xmm2, 352(%edi)
	movaps	%xmm3, 368(%edi)
	movaps	384(%esi), %xmm0
	movaps	400(%esi), %xmm1
	movaps	416(%esi), %xmm2
	movaps	432(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movaps	%xmm0, 384(%edi)
	movaps	%xmm1, 400(%edi)
	movaps	%xmm2, 416(%edi)
	movaps	%xmm3, 432(%edi)
	movaps	448(%esi), %xmm0
	movaps	464(%esi), %xmm1
	movaps	480(%esi), %xmm2
	movaps	496(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movaps	%xmm0, 448(%edi)
	movaps	%xmm1, 464(%edi)
	movaps	%xmm2, 480(%edi)
	movaps	%xmm3, 496(%edi)
	addl	$512, %esi
	addl	$512, %edi
	decl	%ebx
	jnz	.mainsc

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.mainsc

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  ssead
ssead:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %ebp
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
	shrl	$4, %ecx
	finit
	fldpi
.pread:
	fst	0(%edx)
	fst	4(%edx)
	fst	8(%edx)
	fst	12(%edx)
	fst	0(%eax)
	fst	4(%eax)
	fst	8(%eax)
	fst	12(%eax)
	addl	$16, %edx
	addl	$16, %eax
	loopl	.pread
	ffree	%st(0)
/* wall time (start) */
	movl $0, 4(%esp)
	leal 32(%esp), %eax
	movl %eax, 0(%esp)
	call gettimeofday
/* execute */
	shrl	$9, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$512, %edx
.mainad:
	movaps	0(%esi), %xmm0
	movaps	16(%esi), %xmm1
	movaps	32(%esi), %xmm2
	movaps	48(%esi), %xmm3
	addps	0(%ebp), %xmm0
	addps	16(%ebp), %xmm1
	addps	32(%ebp), %xmm2
	addps	48(%ebp), %xmm3
	movaps	%xmm0, 0(%edi)
	movaps	%xmm1, 16(%edi)
	movaps	%xmm2, 32(%edi)
	movaps	%xmm3, 48(%edi)
	movaps	64(%esi), %xmm0
	movaps	80(%esi), %xmm1
	movaps	96(%esi), %xmm2
	movaps	112(%esi), %xmm3
	addps	64(%ebp), %xmm0
	addps	80(%ebp), %xmm1
	addps	96(%ebp), %xmm2
	addps	112(%ebp), %xmm3
	movaps	%xmm0, 64(%edi)
	movaps	%xmm1, 80(%edi)
	movaps	%xmm2, 96(%edi)
	movaps	%xmm3, 112(%edi)
	movaps	128(%esi), %xmm0
	movaps	144(%esi), %xmm1
	movaps	160(%esi), %xmm2
	movaps	176(%esi), %xmm3
	addps	128(%ebp), %xmm0
	addps	144(%ebp), %xmm1
	addps	160(%ebp), %xmm2
	addps	176(%ebp), %xmm3
	movaps	%xmm0, 128(%edi)
	movaps	%xmm1, 144(%edi)
	movaps	%xmm2, 160(%edi)
	movaps	%xmm3, 176(%edi)
	movaps	192(%esi), %xmm0
	movaps	208(%esi), %xmm1
	movaps	224(%esi), %xmm2
	movaps	240(%esi), %xmm3
	addps	192(%ebp), %xmm0
	addps	208(%ebp), %xmm1
	addps	224(%ebp), %xmm2
	addps	240(%ebp), %xmm3
	movaps	%xmm0, 192(%edi)
	movaps	%xmm1, 208(%edi)
	movaps	%xmm2, 224(%edi)
	movaps	%xmm3, 240(%edi)
	movaps	256(%esi), %xmm0
	movaps	272(%esi), %xmm1
	movaps	288(%esi), %xmm2
	movaps	304(%esi), %xmm3
	addps	256(%ebp), %xmm0
	addps	272(%ebp), %xmm1
	addps	288(%ebp), %xmm2
	addps	304(%ebp), %xmm3
	movaps	%xmm0, 256(%edi)
	movaps	%xmm1, 272(%edi)
	movaps	%xmm2, 288(%edi)
	movaps	%xmm3, 304(%edi)
	movaps	320(%esi), %xmm0
	movaps	336(%esi), %xmm1
	movaps	352(%esi), %xmm2
	movaps	368(%esi), %xmm3
	addps	320(%ebp), %xmm0
	addps	336(%ebp), %xmm1
	addps	352(%ebp), %xmm2
	addps	368(%ebp), %xmm3
	movaps	%xmm0, 320(%edi)
	movaps	%xmm1, 336(%edi)
	movaps	%xmm2, 352(%edi)
	movaps	%xmm3, 368(%edi)
	movaps	384(%esi), %xmm0
	movaps	400(%esi), %xmm1
	movaps	416(%esi), %xmm2
	movaps	432(%esi), %xmm3
	addps	384(%ebp), %xmm0
	addps	400(%ebp), %xmm1
	addps	416(%ebp), %xmm2
	addps	432(%ebp), %xmm3
	movaps	%xmm0, 384(%edi)
	movaps	%xmm1, 400(%edi)
	movaps	%xmm2, 416(%edi)
	movaps	%xmm3, 432(%edi)
	movaps	448(%esi), %xmm0
	movaps	464(%esi), %xmm1
	movaps	480(%esi), %xmm2
	movaps	496(%esi), %xmm3
	addps	448(%ebp), %xmm0
	addps	464(%ebp), %xmm1
	addps	480(%ebp), %xmm2
	addps	496(%ebp), %xmm3
	movaps	%xmm0, 448(%edi)
	movaps	%xmm1, 464(%edi)
	movaps	%xmm2, 480(%edi)
	movaps	%xmm3, 496(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.mainad

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.mainad

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%ebp, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  ssetr
ssetr:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %ebp
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
	shrl	$4, %ecx
	finit
	fldpi
.pretr:
	fst	0(%edx)
	fst	4(%edx)
	fst	8(%edx)
	fst	12(%edx)
	fst	0(%eax)
	fst	4(%eax)
	fst	8(%eax)
	fst	12(%eax)
	addl	$16, %edx
	addl	$16, %eax
	loopl	.pretr
	ffree	%st(0)
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	8(%esp)
	fst	12(%esp)
	fst	16(%esp)
	fst	20(%esp)
	movups	8(%esi), %xmm4
	ffree	%st(0)
/* execute */
	shrl	$9, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$512, %edx
.maintr:
	movaps	0(%ebp), %xmm0
	movaps	16(%ebp), %xmm1
	movaps	32(%ebp), %xmm2
	movaps	48(%ebp), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	addps	0(%esi), %xmm0
	addps	16(%esi), %xmm1
	addps	32(%esi), %xmm2
	addps	48(%esi), %xmm3
	movaps	%xmm0, 0(%edi)
	movaps	%xmm1, 16(%edi)
	movaps	%xmm2, 32(%edi)
	movaps	%xmm3, 48(%edi)	
	movaps	64(%ebp), %xmm0
	movaps	80(%ebp), %xmm1
	movaps	96(%ebp), %xmm2
	movaps	112(%ebp), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	addps	64(%esi), %xmm0
	addps	80(%esi), %xmm1
	addps	96(%esi), %xmm2
	addps	112(%esi), %xmm3
	movaps	%xmm0, 64(%edi)
	movaps	%xmm1, 80(%edi)
	movaps	%xmm2, 96(%edi)
	movaps	%xmm3, 112(%edi)
	movaps	128(%ebp), %xmm0
	movaps	144(%ebp), %xmm1
	movaps	160(%ebp), %xmm2
	movaps	176(%ebp), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	addps	128(%esi), %xmm0
	addps	144(%esi), %xmm1
	addps	160(%esi), %xmm2
	addps	176(%esi), %xmm3
	movaps	%xmm0, 128(%edi)
	movaps	%xmm1, 144(%edi)
	movaps	%xmm2, 160(%edi)
	movaps	%xmm3, 176(%edi)
	movaps	192(%ebp), %xmm0
	movaps	208(%ebp), %xmm1
	movaps	224(%ebp), %xmm2
	movaps	240(%ebp), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3	
	addps	192(%esi), %xmm0
	addps	208(%esi), %xmm1
	addps	224(%esi), %xmm2
	addps	240(%esi), %xmm3
	movaps	%xmm0, 192(%edi)
	movaps	%xmm1, 208(%edi)
	movaps	%xmm2, 224(%edi)
	movaps	%xmm3, 240(%edi)
	movaps	256(%ebp), %xmm0
	movaps	272(%ebp), %xmm1
	movaps	288(%ebp), %xmm2
	movaps	304(%ebp), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	addps	256(%esi), %xmm0
	addps	272(%esi), %xmm1
	addps	288(%esi), %xmm2
	addps	304(%esi), %xmm3
	movaps	%xmm0, 256(%edi)
	movaps	%xmm1, 272(%edi)
	movaps	%xmm2, 288(%edi)
	movaps	%xmm3, 304(%edi)
	movaps	320(%ebp), %xmm0
	movaps	336(%ebp), %xmm1
	movaps	352(%ebp), %xmm2
	movaps	368(%ebp), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	addps	320(%esi), %xmm0
	addps	336(%esi), %xmm1
	addps	352(%esi), %xmm2
	addps	368(%esi), %xmm3
	movaps	%xmm0, 320(%edi)
	movaps	%xmm1, 336(%edi)
	movaps	%xmm2, 352(%edi)
	movaps	%xmm3, 368(%edi)
	movaps	384(%ebp), %xmm0
	movaps	400(%ebp), %xmm1
	movaps	416(%ebp), %xmm2
	movaps	432(%ebp), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	addps	384(%esi), %xmm0
	addps	400(%esi), %xmm1
	addps	416(%esi), %xmm2
	addps	432(%esi), %xmm3
	movaps	%xmm0, 384(%edi)
	movaps	%xmm1, 400(%edi)
	movaps	%xmm2, 416(%edi)
	movaps	%xmm3, 432(%edi)
	movaps	448(%ebp), %xmm0
	movaps	464(%ebp), %xmm1
	movaps	480(%ebp), %xmm2
	movaps	496(%ebp), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3	
	addps	448(%esi), %xmm0
	addps	464(%esi), %xmm1
	addps	480(%esi), %xmm2
	addps	496(%esi), %xmm3
	movaps	%xmm0, 448(%edi)
	movaps	%xmm1, 464(%edi)
	movaps	%xmm2, 480(%edi)
	movaps	%xmm3, 496(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.maintr

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.maintr

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%ebp, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret
