/*
**  SSEmem benchmarks for RAMspeed (i386, malloc()-friendly)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2004-05 Rhett M. Hollander <rhett@alasir.com>
**  Copyright (c) 2005 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

/* NOTE: this code has been derived from the original SSEmem code, but it
 * contains work-arounds against badly written malloc() functions, which
 * return addresses not aligned at 16-byte boundaries, thus causing the
 * original code to fail with a segmentation fault most likely; the GNU C
 * library of different versions shows such an ignorant behaviour - PVB */

.globl  ssecp
ssecp:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	shrl	$4, %ecx
	finit
	fldpi
.precp:
	fst	0(%edx)
	fst	4(%edx)
	fst	8(%edx)
	fst	12(%edx)
	addl	$16, %edx
	loopl	.precp
	ffree	%st(0)
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* execute */
	shrl	$9, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.maincp:
	movups	0(%esi), %xmm0
	movups	16(%esi), %xmm1
	movups	32(%esi), %xmm2
	movups	48(%esi), %xmm3
	movups	%xmm0, 0(%edi)
	movups	%xmm1, 16(%edi)
	movups	%xmm2, 32(%edi)
	movups	%xmm3, 48(%edi)
	movups	64(%esi), %xmm0
	movups	80(%esi), %xmm1
	movups	96(%esi), %xmm2
	movups	112(%esi), %xmm3
	movups	%xmm0, 64(%edi)
	movups	%xmm1, 80(%edi)
	movups	%xmm2, 96(%edi)
	movups	%xmm3, 112(%edi)
	movups	128(%esi), %xmm0
	movups	144(%esi), %xmm1
	movups	160(%esi), %xmm2
	movups	176(%esi), %xmm3
	movups	%xmm0, 128(%edi)
	movups	%xmm1, 144(%edi)
	movups	%xmm2, 160(%edi)
	movups	%xmm3, 176(%edi)
	movups	192(%esi), %xmm0
	movups	208(%esi), %xmm1
	movups	224(%esi), %xmm2
	movups	240(%esi), %xmm3
	movups	%xmm0, 192(%edi)
	movups	%xmm1, 208(%edi)
	movups	%xmm2, 224(%edi)
	movups	%xmm3, 240(%edi)
	movups	256(%esi), %xmm0
	movups	272(%esi), %xmm1
	movups	288(%esi), %xmm2
	movups	304(%esi), %xmm3
	movups	%xmm0, 256(%edi)
	movups	%xmm1, 272(%edi)
	movups	%xmm2, 288(%edi)
	movups	%xmm3, 304(%edi)
	movups	320(%esi), %xmm0
	movups	336(%esi), %xmm1
	movups	352(%esi), %xmm2
	movups	368(%esi), %xmm3
	movups	%xmm0, 320(%edi)
	movups	%xmm1, 336(%edi)
	movups	%xmm2, 352(%edi)
	movups	%xmm3, 368(%edi)
	movups	384(%esi), %xmm0
	movups	400(%esi), %xmm1
	movups	416(%esi), %xmm2
	movups	432(%esi), %xmm3
	movups	%xmm0, 384(%edi)
	movups	%xmm1, 400(%edi)
	movups	%xmm2, 416(%edi)
	movups	%xmm3, 432(%edi)
	movups	448(%esi), %xmm0
	movups	464(%esi), %xmm1
	movups	480(%esi), %xmm2
	movups	496(%esi), %xmm3
	movups	%xmm0, 448(%edi)
	movups	%xmm1, 464(%edi)
	movups	%xmm2, 480(%edi)
	movups	%xmm3, 496(%edi)
	addl	$512, %esi
	addl	$512, %edi
	decl	%ebx
	jnz	.maincp

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.maincp

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  ssesc
ssesc:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	shrl	$4, %ecx
	finit
	fldpi
.presc:
	fst	0(%edx)
	fst	4(%edx)
	fst	8(%edx)
	fst	12(%edx)
	addl	$16, %edx
	loopl	.presc
	ffree	%st(0)
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	8(%esp)
	fst	12(%esp)
	fst	16(%esp)
	fst	20(%esp)
	movups	8(%esp), %xmm4
	ffree	%st(0)
/* execute */
	shrl	$9, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.mainsc:
	movups	0(%esi), %xmm0
	movups	16(%esi), %xmm1
	movups	32(%esi), %xmm2
	movups	48(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movups	%xmm0, 0(%edi)
	movups	%xmm1, 16(%edi)
	movups	%xmm2, 32(%edi)
	movups	%xmm3, 48(%edi)
	movups	64(%esi), %xmm0
	movups	80(%esi), %xmm1
	movups	96(%esi), %xmm2
	movups	112(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movups	%xmm0, 64(%edi)
	movups	%xmm1, 80(%edi)
	movups	%xmm2, 96(%edi)
	movups	%xmm3, 112(%edi)
	movups	128(%esi), %xmm0
	movups	144(%esi), %xmm1
	movups	160(%esi), %xmm2
	movups	176(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movups	%xmm0, 128(%edi)
	movups	%xmm1, 144(%edi)
	movups	%xmm2, 160(%edi)
	movups	%xmm3, 176(%edi)
	movups	192(%esi), %xmm0
	movups	208(%esi), %xmm1
	movups	224(%esi), %xmm2
	movups	240(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movups	%xmm0, 192(%edi)
	movups	%xmm1, 208(%edi)
	movups	%xmm2, 224(%edi)
	movups	%xmm3, 240(%edi)
	movups	256(%esi), %xmm0
	movups	272(%esi), %xmm1
	movups	288(%esi), %xmm2
	movups	304(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movups	%xmm0, 256(%edi)
	movups	%xmm1, 272(%edi)
	movups	%xmm2, 288(%edi)
	movups	%xmm3, 304(%edi)
	movups	320(%esi), %xmm0
	movups	336(%esi), %xmm1
	movups	352(%esi), %xmm2
	movups	368(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movups	%xmm0, 320(%edi)
	movups	%xmm1, 336(%edi)
	movups	%xmm2, 352(%edi)
	movups	%xmm3, 368(%edi)
	movups	384(%esi), %xmm0
	movups	400(%esi), %xmm1
	movups	416(%esi), %xmm2
	movups	432(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movups	%xmm0, 384(%edi)
	movups	%xmm1, 400(%edi)
	movups	%xmm2, 416(%edi)
	movups	%xmm3, 432(%edi)
	movups	448(%esi), %xmm0
	movups	464(%esi), %xmm1
	movups	480(%esi), %xmm2
	movups	496(%esi), %xmm3
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	mulps	%xmm4, %xmm2
	mulps	%xmm4, %xmm3
	movups	%xmm0, 448(%edi)
	movups	%xmm1, 464(%edi)
	movups	%xmm2, 480(%edi)
	movups	%xmm3, 496(%edi)
	addl	$512, %esi
	addl	$512, %edi
	decl	%ebx
	jnz	.mainsc

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.mainsc

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  ssead
ssead:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %ebp
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
	shrl	$4, %ecx
	finit
	fldpi
.pread:
	fst	0(%edx)
	fst	4(%edx)
	fst	8(%edx)
	fst	12(%edx)
	fst	0(%eax)
	fst	4(%eax)
	fst	8(%eax)
	fst	12(%eax)
	addl	$16, %edx
	addl	$16, %eax
	loopl	.pread
	ffree	%st(0)
/* wall time (start) */
	movl $0, 4(%esp)
	leal 32(%esp), %eax
	movl %eax, 0(%esp)
	call gettimeofday
/* execute */
	shrl	$9, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$512, %edx
.mainad:
	movups	0(%esi), %xmm0
	movups	16(%esi), %xmm1
	movups	32(%esi), %xmm2
	movups	48(%esi), %xmm3
	movups	0(%ebp), %xmm4
	movups	16(%ebp), %xmm5
	movups	32(%ebp), %xmm6
	movups	48(%ebp), %xmm7
	addps	%xmm4, %xmm0
	addps	%xmm5, %xmm1
	addps	%xmm6, %xmm2
	addps	%xmm7, %xmm3
	movups	%xmm0, 0(%edi)
	movups	%xmm1, 16(%edi)
	movups	%xmm2, 32(%edi)
	movups	%xmm3, 48(%edi)
	movups	64(%esi), %xmm0
	movups	80(%esi), %xmm1
	movups	96(%esi), %xmm2
	movups	112(%esi), %xmm3
	movups	64(%ebp), %xmm4
	movups	80(%ebp), %xmm5
	movups	96(%ebp), %xmm6
	movups	112(%ebp), %xmm7
	addps	%xmm4, %xmm0
	addps	%xmm5, %xmm1
	addps	%xmm6, %xmm2
	addps	%xmm7, %xmm3
	movups	%xmm0, 64(%edi)
	movups	%xmm1, 80(%edi)
	movups	%xmm2, 96(%edi)
	movups	%xmm3, 112(%edi)
	movups	128(%esi), %xmm0
	movups	144(%esi), %xmm1
	movups	160(%esi), %xmm2
	movups	176(%esi), %xmm3
	movups	128(%ebp), %xmm4
	movups	144(%ebp), %xmm5
	movups	160(%ebp), %xmm6
	movups	176(%ebp), %xmm7
	addps	%xmm4, %xmm0
	addps	%xmm5, %xmm1
	addps	%xmm6, %xmm2
	addps	%xmm7, %xmm3
	movups	%xmm0, 128(%edi)
	movups	%xmm1, 144(%edi)
	movups	%xmm2, 160(%edi)
	movups	%xmm3, 176(%edi)
	movups	192(%esi), %xmm0
	movups	208(%esi), %xmm1
	movups	224(%esi), %xmm2
	movups	240(%esi), %xmm3
	movups	192(%ebp), %xmm4
	movups	208(%ebp), %xmm5
	movups	224(%ebp), %xmm6
	movups	240(%ebp), %xmm7
	addps	%xmm4, %xmm0
	addps	%xmm5, %xmm1
	addps	%xmm6, %xmm2
	addps	%xmm7, %xmm3
	movups	%xmm0, 192(%edi)
	movups	%xmm1, 208(%edi)
	movups	%xmm2, 224(%edi)
	movups	%xmm3, 240(%edi)
	movups	256(%esi), %xmm0
	movups	272(%esi), %xmm1
	movups	288(%esi), %xmm2
	movups	304(%esi), %xmm3
	movups	256(%ebp), %xmm4
	movups	272(%ebp), %xmm5
	movups	288(%ebp), %xmm6
	movups	304(%ebp), %xmm7
	addps	%xmm4, %xmm0
	addps	%xmm5, %xmm1
	addps	%xmm6, %xmm2
	addps	%xmm7, %xmm3
	movups	%xmm0, 256(%edi)
	movups	%xmm1, 272(%edi)
	movups	%xmm2, 288(%edi)
	movups	%xmm3, 304(%edi)
	movups	320(%esi), %xmm0
	movups	336(%esi), %xmm1
	movups	352(%esi), %xmm2
	movups	368(%esi), %xmm3
	movups	320(%ebp), %xmm4
	movups	336(%ebp), %xmm5
	movups	352(%ebp), %xmm6
	movups	368(%ebp), %xmm7
	addps	%xmm4, %xmm0
	addps	%xmm5, %xmm1
	addps	%xmm6, %xmm2
	addps	%xmm7, %xmm3
	movups	%xmm0, 320(%edi)
	movups	%xmm1, 336(%edi)
	movups	%xmm2, 352(%edi)
	movups	%xmm3, 368(%edi)
	movups	384(%esi), %xmm0
	movups	400(%esi), %xmm1
	movups	416(%esi), %xmm2
	movups	432(%esi), %xmm3
	movups	384(%ebp), %xmm4
	movups	400(%ebp), %xmm5
	movups	416(%ebp), %xmm6
	movups	432(%ebp), %xmm7
	addps	%xmm4, %xmm0
	addps	%xmm5, %xmm1
	addps	%xmm6, %xmm2
	addps	%xmm7, %xmm3
	movups	%xmm0, 384(%edi)
	movups	%xmm1, 400(%edi)
	movups	%xmm2, 416(%edi)
	movups	%xmm3, 432(%edi)
	movups	448(%esi), %xmm0
	movups	464(%esi), %xmm1
	movups	480(%esi), %xmm2
	movups	496(%esi), %xmm3
	movups	448(%ebp), %xmm4
	movups	464(%ebp), %xmm5
	movups	480(%ebp), %xmm6
	movups	496(%ebp), %xmm7
	addps	%xmm4, %xmm0
	addps	%xmm5, %xmm1
	addps	%xmm6, %xmm2
	addps	%xmm7, %xmm3
	movups	%xmm0, 448(%edi)
	movups	%xmm1, 464(%edi)
	movups	%xmm2, 480(%edi)
	movups	%xmm3, 496(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.mainad

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.mainad

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%ebp, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  ssetr
ssetr:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate */
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, 0(%esp)
	call	malloc
	movl	%eax, %esi
/* allocate */
	call	malloc
	movl	%eax, %ebp
/* allocate */
	call	malloc
	movl	%eax, %edi
/* prefill */
	movl	%ebx, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
	shrl	$4, %ecx
	finit
	fldpi
.pretr:
	fst	0(%edx)
	fst	4(%edx)
	fst	8(%edx)
	fst	12(%edx)
	fst	0(%eax)
	fst	4(%eax)
	fst	8(%eax)
	fst	12(%eax)
	addl	$16, %edx
	addl	$16, %eax
	loopl	.pretr
	ffree	%st(0)
/* wall time (start) */
	movl	$0, 4(%esp)
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	8(%esp)
	fst	12(%esp)
	fst	16(%esp)
	fst	20(%esp)
	movups	8(%esi), %xmm4
	ffree	%st(0)
/* execute */
	shrl	$9, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$512, %edx
.maintr:
	movups	0(%ebp), %xmm0
	movups	16(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	0(%esi), %xmm2
	movups	16(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 0(%edi)
	movups	%xmm1, 16(%edi)
	movups	32(%ebp), %xmm0
	movups	48(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	32(%esi), %xmm2
	movups	48(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 32(%edi)
	movups	%xmm1, 48(%edi)	
	movups	64(%ebp), %xmm0
	movups	80(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	64(%esi), %xmm2
	movups	80(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 64(%edi)
	movups	%xmm1, 80(%edi)
	movups	96(%ebp), %xmm0
	movups	112(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	96(%esi), %xmm2
	movups	112(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 96(%edi)
	movups	%xmm1, 112(%edi)
	movups	128(%ebp), %xmm0
	movups	144(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	128(%esi), %xmm2
	movups	144(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 128(%edi)
	movups	%xmm1, 144(%edi)
	movups	160(%ebp), %xmm0
	movups	176(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	160(%esi), %xmm2
	movups	176(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 160(%edi)
	movups	%xmm1, 176(%edi)
	movups	192(%ebp), %xmm0
	movups	208(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	192(%esi), %xmm2
	movups	208(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 192(%edi)
	movups	%xmm1, 208(%edi)
	movups	224(%ebp), %xmm0
	movups	240(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	224(%esi), %xmm2
	movups	240(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 224(%edi)
	movups	%xmm1, 240(%edi)
	movups	256(%ebp), %xmm0
	movups	272(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	256(%esi), %xmm2
	movups	272(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 256(%edi)
	movups	%xmm1, 272(%edi)
	movups	288(%ebp), %xmm0
	movups	304(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	288(%esi), %xmm2
	movups	304(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 288(%edi)
	movups	%xmm1, 304(%edi)
	movups	320(%ebp), %xmm0
	movups	336(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	320(%esi), %xmm2
	movups	336(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 320(%edi)
	movups	%xmm1, 336(%edi)
	movups	352(%ebp), %xmm0
	movups	368(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	352(%esi), %xmm2
	movups	368(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 352(%edi)
	movups	%xmm1, 368(%edi)
	movups	384(%ebp), %xmm0
	movups	400(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	384(%esi), %xmm2
	movups	400(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 384(%edi)
	movups	%xmm1, 400(%edi)
	movups	416(%ebp), %xmm0
	movups	432(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	416(%esi), %xmm2
	movups	432(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 416(%edi)
	movups	%xmm1, 432(%edi)
	movups	448(%ebp), %xmm0
	movups	464(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	448(%esi), %xmm2
	movups	464(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 448(%edi)
	movups	%xmm1, 464(%edi)
	movups	480(%ebp), %xmm0
	movups	496(%ebp), %xmm1
	mulps	%xmm4, %xmm0
	mulps	%xmm4, %xmm1
	movups	480(%esi), %xmm2
	movups	496(%esi), %xmm3
	addps	%xmm2, %xmm0
	addps	%xmm3, %xmm1
	movups	%xmm0, 480(%edi)
	movups	%xmm1, 496(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.maintr

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.maintr

/* wall time (finish) */
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	gettimeofday
/* free */
	movl	%edi, 0(%esp)
	call	free
/* free */
	movl	%ebp, 0(%esp)
	call	free
/* free */
	movl	%esi, 0(%esp)
	call	free
/* calculate */
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	$1000000, %edx
	mull	%edx
	addl	44(%esp), %eax
	subl	36(%esp), %eax
/* restore and return */
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret
